// ResGen.cpp : Defines the entry point for the console application.
//

// This program was made by Jeroen Bogers, aka ShadowLord
// You may freely distibute and modify this program as long as you give me credit and
// include my e-mail adress (resgen@hltools.com)
//
//
// Have fun editing this code. I hope you can improve it!
// BTW. It would be nice if you kept me posted on your changes.
// That way we can both learn from each other!
//
// Also I'd like to appoligise for the occasional bad english.
// English isn't my first language (for the curious: I am Dutch :). I also like to spend more time on
// coding then checking the comments and manulas for spelling errors :)

// ResGen return list - useable for batch scripts (if errorlevel x goto label)
// 0 = All OK
// 1 = general error
// 2 = Memory allocation error
// 3 = command line error
// 4 = Addition file error

// RESGen command line parameters
// Moved clp's to the HELP function (where it's needed the most :)

// NOTE: RESGen seems to be much faster if the binary ISN'T optimized for SPEED (MSVC++ 6 SP4).

// LINUX NOTES:
//   - The -w option isn't available on linux: Linux doesn't use consoles like Win32.
//   - The linux version is a derivative of the Win32 version. It uses the same code layout as
//     the Win32 version, but I have tried to make it as efficient as possible for Linux.

// PLEASE NOTE:
// You might notice the new E-Mail adress (resgen@hltools.com). Don't worry, the old one is still valid.
// You can find the RESGen homepage on http://resgen.hltools.com
// I will try to make sure it always points to the valid UnitedAdmins page.

// Version info
// v1.12
//   - After expirimenting a bit with those long directory names I found out Windows can't even create such
//     long paths. I removed the routines that checked for long paths since they only take up valuable CPU
//     time...
//
// v1.12 & v1.12_l
//   - Removed the path to the res file in the resfile itself (// cs_estate.res - created with RESGen v1.11)
//     It used to add the path from where it was created too.
//   - JTP10181 notified me of a bug with RESGen. Apparently any resource name starting with a number wasn't
//     properly added to the res file. The number got stripped.
//     I have traced down this bug to an error with the function that checks for resoucre names starting
//     with illigal ASCII chars. It tried to match the numbers 1 to 0, wich obviously will fail. It seems
//     I assumed that the ASCII table used 1234567890, but it actually uses 0123456789.
//     The error has been fixed, and it now checks for 0 to 9.
//
// v1.10
//   - Fixed a bug with very long directory names. The windows functions used to read files have a limit
//     on how long a path string can be (260 characters). This has been corrected by making
//     RESGen switch working directories as soon as it seems the path will get too long. The only
//     limit now is the file system (but it's impossible to create files outside the limits of the file
//     system, so no worries there :)
//   - Also fixed another bug with the path length. When searching for maps, RESGen displays the current
//     directory its searching in the status bar. If it exceeded 80 characters,
//     it resulted in unexpected behaviour and might even crash. This has been corrected.
//
// v1.10_l
//   - Added a display of the current directory being searched for .bsp files. Can be disabled with -i switch.
//     -s also disables this.
//
// v1.10 & v1.10_l
//   - I upgraded VString and VArray for some other project I have been working on. I ported the changes
//     back to RESGen. You should see a HUGE speed increase!!!
//
// v1.00 & v1.00_l
//   - Made a huge improvement to BSP file loading. The continual use of memory is much lower,
//     And the memory usage spike when loading the BSP file is gone.
//     RESGen used to load the entire BSP file to mem, copy the stuff it wanted to another
//     memory locattion and then unloaded the BSP file from memory.
//     Now RESGen only loads the part of the BSP header it needs, gets the location of the
//     data it needs and then only loads that data into mem.
//     This will also greatly reduce the loading time of the BSP files.
//
// v0.76 & v0.76_l
//   - Made a few changes that will speed things up a bit (not much).
//   - If this version contains no bugs the next one will probably be v1.00!!!
//   - Added protection against corrupted BSP file headers. 
//
// v0.76_l
//   - Fixed problem with statbar showing up in non-verbal mode.
//   - Added -t option. -t stops resgen from tracing symbolic links when searching directories
//     for bsp files (the symbolic links will be ignored). To be used with -r or -d.
//   - RESGen now checks for dirs the way it should... By 'file' properties. And not by trying to open it.
//   - Fixed minor bug with displaying statbar. It should display more consistent now.
//
// v0.75_l
//   - Added directory support to the linux version.
//   - Linux now has a statusbar substitute. It also prints the number of the BSP file that is being
//     processed when it starts with the BSP file.
//
// v0.71_l
//   - This version is linux capable... There are no changes to the Win32 version.
//     Some things were changed to the code (mostly usaged if #ifdef _WIN32 en #ifndef _WIN32).
//
// v0.71 & v0.71_l
//   - Made some small speed increases regarding the allocation of memory for strings (tnx mjr!)
//
// v0.70
//   - A test on a linux Half-Life server revealed that all file entries in the res file need
//     to have the same case as the files and folders on the server.
//     However, some mappers make a mess of their file cases and thus the .res file will be unusable.
//     To prevent this all res entries will be made lower case, since that is the 'official' *nix
//     file naming convention. This behaviour can be overridden with the commnd-line option -l.
//   - ResGen will now add comment lines to .res files.
//   - ResGen will now not overwrite .res files unless you specify -o or -u
//   - The -u command allows you to update your older resfiles from the specified creation date
//   - It is now possible to add a custom file to the end of a .res file that has been generated.
//   - ResGen will not wait for any keypresses if you run it with -w.
//
// v0.65
//   - Made a huge speed increase. ResGen will only check 50% of all 'strings' in the entity data.
//     This can be done because all strings are pairs... A name and a corresponding argument.
//     Only the arguments will contain files.
//     The only thing that gets checked in the name is the word 'skyname'.
//   - Made some small speed increases.
//   - Got rid of the Valve source files... They used way to much mem ResGen didn't need. I copied all
//     vars and functions ResGen needs to bspent.cpp and bspent.h
//     Memory usage has decreased dramaticly!
//   - Removed a bug that only shows up sometimes in multiple file mode. The BSP reading functions
//     from Valve did not place a string terminator (NULL) at the end of the string.
//     It's kinda complicated to explain, but the result is that ResGen ends up reading map data
//     from previous maps. Somtimes this will cause no problems, sometimes it will generate file entries
//     in a resource file that aren't supposed to be there and sometimes RESGen will crash or exit with
//     an error message.
//
// v0.60
//   - Improved commandline parameters even more. You can now do something like "resgen -dv half-life"
//   - Directory support added. Dropped -drive command (you can do "-r C:\", which has teh same effect)
//   - Fixed another problem with wad files. The problem was that if there is only 1 wad file,
//     not terminated by a ";", ResGen would crash (it couldn't find the ";", which made it do a
//     'Mid ' with a negative string size... Ouch!
//   - Improved statusbar. Now there are 2 bars. They will give you all the info you need.
//     The best new thing is that there is a 'total progress' bar. And it displays resgen version.
//
// v0.55
//   - Added much better command line support.
//   - Added support for multiple files.
//   - Added a status bar similar to the HL status bar. It displays the progress of the res
//     generation for the current map.
//
// v0.51
//   - As I suspected v0.50 was one big black hole for memory.. It went inside, but didn't come out.
//     All memory 'holes' should have been 'plugged' now.
//
// v0.50
//   - The fixed arrays have been replaced with linked lists. Now there can be as many unique files
//     in the BSP as you have memory!
//   - Notes: Yes this is v0.50! I consider the BSP parsing engine as done, unless I get any bug
//     reports. v0.50 will parse any BSP file correctly and can be seen as a semi-final version of
//     resgen. After this version I will be concentrating on possible bugfixes and the items found
//     in the todo list (see resgen.txt).
//
// v0.14
//   - CString is a goner. And with it, the MFC too!
//     I'm doing a lot with the memory in this code. As far as I know there are no bugs with the
//     memory management. But IF you experience strange lockups with resgen, please tell me and
//     include what map you were working on!
//   - The only 'bug' that should be left is the fact that there can be only 100 unique files of
//     a type in a map. If there are more resgen will exit with an error.
//     This should be adressed in the next version. That version will probably be v0.50
//   - A 'feature' of this version is that it will overwrite your resfile with a new one.
//     This wil be changed after v0.50, when I start on directory browsing & file management.
//
// v0.13MFC
//   - Fixed stupid bug with the skynames. resgen only generated the up-sky and didn't do the others.
//
// v0.12MFC
//   - Bugfix: wad files without folder specification were ignored. This has been fixed.
//     In relation to this bugfix there is also NO need anymore to specify the MOD!
//   - Bugfix: the wad file string was still too long for the string-arrays.
//     All strings are converted to CString... Becasue of this the MFC libraries had to be added.
//     The MFC libraries will be removed once I write my own CString class.
//     A side-effect of the MFC libraries is the inability to use fstream.h
//     Output file streaming options have been replaced with stdio functions.
//
// v0.11
//   - Bugfix: Maps made with zoner's half life tools could overflow some data arrays in bspfile.cpp
//     The values have been increased to match those of zoners and the faulty maps now will load.
//   - Bugfix: Some entries have a leading / or *. These will be removed.
//     This fix should be upgraded to the removal of all leading non ascii chars.
//   - Bugfix: The array chosen for strings was too small, so the list of wads would get turncated.
//     The size is still potentially too small, but this can only be fixed with a linked list.
//     That will be done in a future version, using multiple linked lists.
//
// v0.10
//   - Major changes! The BSP reading routines have been completely replaced by the BSP file
//     reading routines by Valve. The files used are C++ ports of their orriginal, Valve made,
//     counterparts.
//     The way it works now, is that it lets the files by Valve open the BSP and parse it into mem.
//     From there ResGen takes over and reads the entity-data.
//   - Preformance is still not too good, but much better.
//   - ResGen should parse any wad file correctly, unless it's corrupted.
//   - This release will be distributed to the public.
//
// v0.03
//   - Minor fix. The last wad file will now be added, even if there is no terminating ";"
//
// v0.02
//   - First test release.
//   - Has much problems with skipping the binary part of the BSP, due to EOF chars inside that part.
//     A fix would be to find a function that will binary read the file.
//   - Has a small bug with the wad files. If the string of files isn't terminated by a ";", the program
//     will refuse to read the last wad file.
//   - Preformance is really lousy. Especially the storage arrays for the files that have been added to
//     the res file. These should be linked lists.

#include "resgen.h"

#ifdef _WIN32
void WriteStatusText( char *text, WORD linecolor, int pos)
{
	char line[81];
	COORD coord;
	DWORD Written = 0;
	WORD Attrib[80];
	
	int i;
	
	for ( i = 0; i < 80; i++ )
	{
		Attrib[i] = linecolor;
	}

	strcpy( line, text );
	line[80] = 0; // Add trailing 0

	coord.X = 0;
	coord.Y = pos;

	WriteConsoleOutputAttribute( houtput, Attrib, 80, coord, &Written );
	WriteConsoleOutputCharacter( houtput, line, 80, coord, &Written );
}


void upstatus()
{
	if (statusline)
	{
		int i;
		// Fill bar 1 up with spaces
		for (i=strlen(sbar1); i < 80; i++)
		{
			sbar1[i] = ' ';
		}
		sbar1[80] = 0;
		// Fill bar 2 up with spaces
		for (i=strlen(sbar2); i < 80; i++)
		{
			sbar2[i] = ' ';
		}
		sbar2[80] = 0;

		// Print both bars to screen
		WriteStatusText(sbar1, FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_INTENSITY, 0); // Write bar 1 (bright yellow)
		WriteStatusText(sbar2, FOREGROUND_RED | FOREGROUND_INTENSITY, 1); // Write bar 2 (bright red)
	}
}


void progressbar(char *output, int total, int done, int length)
{
	int stars;
	int i;
	char *temp;
	temp = new char[length+1];
	if (temp == NULL) { MemError(); }

	// Calculate the number of stars. We add one to the length so the last star will display too.
	// Normally it would only appear for a few msec before the next file will be done :)
	stars = (done * (length + 1)) / total; // Make the length one too long.
	if (stars > length) { stars = length; } // delete the last star if there are too many

	for (i = 0; i < stars; i++)
	{
		temp[i] = '*';
	}
	while (i < length)
	{
		temp[i] = '.';
		i++;
	}
	temp[i] = 0;

	strcat(output, temp);
	delete [] temp;
}
#endif


bool filecheck(VArray *array, VString *file)
{
	int i, acount;
	VString vtemp;

	acount = array->GetCount();
	for (i=0; i < acount; i++)
	{
		if (stricmp(array->Get(i)->Get(), file->Get()) == 0) { return false; }
	}

	vtemp.Set(file->Get());

	array->Add(vtemp.Get());

	//delete vtemp;
	return true;
}


bool legalchar(char *string, int pos = 0)
{
	bool legal;

	bool laz;
	bool UAZ;
	bool number;

	laz = string[pos] >= la && string[pos] <= lz;
	UAZ = string[pos] >= UA && string[pos] <= UZ;
	number = string[pos] >= zero && string[pos] <= nine;

	legal = laz || UAZ || number;
	return legal;
}


void addfile(VString *string, FILE *file, VArray *verify_array, char *prefix = "", char *suffix = "")
{
	VString vtemp; // Temp VSting

	// Strip non ascii chars form the start of the string
	while (!legalchar( string->Get() ))
	{
		// The first char isn't ascii. remove it!
		string->Right(&vtemp, string->GetLength() - 1);
		string->Set(vtemp.Get());
	}

	// Speed up string adding with if checks
	if (strlen(prefix))
	{
		vtemp.Set(prefix);
		vtemp.Cat(string->Get());
	}
	else
	{
		vtemp.Set(string->Get());
	}
	if (strlen(suffix))
	{
		vtemp.Cat(suffix);
	}

	// Check if it hasn't been here before. If it has, don't write it.
	if (filecheck(verify_array, &vtemp) == true)
	{
		if (lowercase) { vtemp.LCase(); } // Convert to lowercase
		if (verbal)
		{
			#ifdef _WIN32
			printf("\r%s\n", vtemp.Get());
			#else
			printf("\r%-10s\n", vtemp.Get());
			statcount = STAT_MAX; //Make sure the stats get immediately updated after this line
			#endif
		}

		fprintf(file, "\n%s", vtemp.Get());
	}
	
	return;
}


int MakeRes(char *bspfilename)
{
	// Possible returns
	// 0 = All OK - return
	// 1 = BSP file open error - retrun
	// 2 = Memory allocation error - exit
	// 3 = BSP syntax error - return
	// 4 = RES file error - return

	VString vtemp; // Needed bcause of VString's inability to overload
	VString filename; // BSP filename

	FILE *resfile; // The filestream to the res file
	VString resfilename; // The res file name

	VString entitydata; // Entity data
	VString line; // A bsp entity

	int j; // Temp counter
	int itemp; // Temp int

	int tday; // Day
	int tmonth; // Month
	int tyear; // Year
	bool founddate = false; // Did we find a date?
	
	int markpos; // Marker position
	int strstart; // Begin marker of string
	VString stemp; // Temp string
	bool skynext; // Is the sky next string?
	bool wadnext; // Is the wadlist the next string?
	bool wadend; // End of the wad line?

	int startquote; // Marker position for opening quotes
	int endquote; // Marker position for closing quotes

	int entdatalen; // Entity data length

	int linelen; // Current line length

	#ifndef _WIN32
	int percentage; // Percentage completed of current file
	#endif

	bool entryarg; // Is the string an entry arg or name?

	// Arrays with found filenames
	// This should be converted to linked list... Sometime
	VArray wad;
	VArray model;
	VArray sprite;
	VArray bitmap;
	VArray sound;
	VArray targa;

	// Copy the BSP filename into a VString
	filename.Set(bspfilename);

	filename.Right(&vtemp, 4);

	// Verify extension. If it's not there/wrong add it
	// If it's still incorrect people will see the appropriate error message anyways.
	if (stricmp(vtemp.Get(), ".bsp") != 0)
	{
		filename.Cat(".bsp");
	}

	// Heavily rely-ing on the code provided by valve to read the bsp!
	// Load the BSP file.
	//itemp = LoadBSPEntities(filename.Get());
	itemp = LoadBSPEntityInfo(filename.Get());
	if (itemp == 2)
	{
		return 3;
	}
	if (itemp != 0)
	{
		return 1;
	}

	// Input file is open, now the output RES file.

	// Make the res filename
	filename.Left(&vtemp, filename.GetLength() - 3);
	vtemp.Cat("res");
	resfilename.Set(vtemp.Get());

	if (!overwrite)
	{
		// We don't want the file to be overwritten
		// try to open the file
		resfile = fopen(resfilename.Get(), "r");

		if (resfile == NULL)
		{
			// The file doesn't exist... Open it for writing
			resfile = fopen(resfilename.Get(), "w"); // Open the file, overwrites any previous files
		}
		else
		{
			// The file exists!
			// Do we want to update old files??
			if (update)
			{
				// Is this file older then what we want?
				while (fgetline(resfile, &vtemp))
				{
					itemp = vtemp.Instr("// Res creation date, GMT timezone (dd-mm-yyyy):", 0);
					if (itemp >= 0)
					{
						founddate = true;
						itemp = vtemp.Instr(":", itemp);
						vtemp.Right(&vtemp, (vtemp.GetLength() - itemp) - 1);
						makedate(&vtemp, &tday, &tmonth, &tyear);

						if (tyear > updyear)
						{
							return 5; // The file is newer...
						}
						else if (tmonth > updmonth)
						{
							return 5; // The file is newer...
						}
						else if (tday >= updday)
						{
							return 5; // The file is newer or the same age...
						}
						else
						{
							break; // to speed up things
						}
					}
				}
				// The file is older or we can't find a date... overwrite the file
				resfile = fopen(resfilename.Get(), "w"); // Open the file, overwrites any previous files
			}
			else
			{
				// File exists and we don't want to update
				fclose(resfile);
				return 4;
			}
		}
	}
	else
	{
		resfile = fopen(resfilename.Get(), "w"); // Open the file, overwrites any previous files
	}
		
	// Print that we are going to process this file.
	if (verbal)
	{
		#ifdef _WIN32
		printf("Making .res file for %s:\n", filename.Get());
		upstatus();
		#else
		printf("Making .res file for %s [%d/%d]:\n", filename.Get(), currentbsp, totalbsp);
		#endif
	}

	// Add comment lines to res file.
	// create actual filename, not path only
	#ifdef _WIN32
	// Win32 '\'
	resfilename.Right(&vtemp, resfilename.GetLength() - resfilename.InstrRev("\\", resfilename.GetLength() - 1) - 1);
	#else
	// Linux '/'
	resfilename.Right(&vtemp, resfilename.GetLength() - resfilename.InstrRev("/", resfilename.GetLength() - 1) - 1);
	#endif

	fprintf(resfile, "// %s - created with RESGen v%s\n", vtemp.Get(), version);
	fprintf(resfile, "// RESGen is made by Jeroen \"ShadowLord\" Bogers\n");
	fprintf(resfile, "// URL: http://www.unitedadmins.com/mapRESGEN.asp\n");
	fprintf(resfile, "// E-MAIL: resgen@hltools.com\n");

	getdate(&vtemp);
	fprintf(resfile, "// Res creation date, GMT timezone (dd-mm-yyyy): %s\n\n", vtemp.Get());
	
	fprintf(resfile, "// .res entries:"); // No newline here.. They get added in front of each entry.

	// Copy the dentdata in a VString
	entitydata.Set(dentdata);

	skynext = false; // Will the next string be the skyname?
	wadnext = false; // Will the next string be the wad-file list?

	#ifndef _WIN32
	statcount = 0; // Reset stat counter (to make screen updates appear less)
	#endif

	// Parse all entity data.
	entdatalen = entitydata.GetLength();

	entryarg = false;
	for (j = 0; j < entdatalen; j++)
	{
		#ifdef _WIN32
		if (statusline)
		{
			strcpy(sbar2, "Progress: [");
			progressbar(sbar2, entdatalen, j+1, 68);
			strcat(sbar2, "]");
			upstatus();
		}
		#endif
		// Put a "" delimited string in line
		startquote = entitydata.Instr("\"", j);
		if (startquote < 0) { break; } // Break if there are no more strings
		endquote = entitydata.Instr("\"", startquote + 1);
		// Break if there are no more strings - this indicates an error however
		if (endquote < 0) { return 3; }

		entitydata.Mid(&vtemp, startquote + 1, (endquote - startquote) - 1);
		line.Set(vtemp.Get());

		j = endquote + 1;

		// Do we have a skyname or not?
		if (skynext)
		{
			entryarg = false; // The next line will be a name.
			// We have a skyname!
			// Check if it hasn't been here before. If it has, don't write it.

			// We are creating all 6 skynames here: up, dn, lf, rt, ft, bk.
			addfile(&line, resfile, &targa, "gfx/env/", "up.tga");
			addfile(&line, resfile, &targa, "gfx/env/", "dn.tga");
			addfile(&line, resfile, &targa, "gfx/env/", "lf.tga");
			addfile(&line, resfile, &targa, "gfx/env/", "rt.tga");
			addfile(&line, resfile, &targa, "gfx/env/", "ft.tga");
			addfile(&line, resfile, &targa, "gfx/env/", "bk.tga");

			skynext = false; // The next files won't be the sky
		}
		else if (wadnext)
		{
			entryarg = false; // The next line will be a name.
			// We have a wad filelist!
			// We have the wad list, lets split it and put it in stdio if necesary.
			markpos = line.Instr(";", 0);
			strstart = 0;
			wadend = false;

			linelen = line.GetLength();
			while (linelen > strstart)
			{
				if (markpos < 0)
				{
					wadend = true;
					markpos = line.GetLength();
				}
				// Get the current wad file
				line.Mid(&vtemp, strstart, markpos - strstart);
				stemp.Set(vtemp.Get());

				itemp = stemp.Instr("\\", 0);
				if (itemp < 0)
				{
					itemp = stemp.Instr("/", 0);
				}

				while (itemp >= 0)
				{
					// Remove the folder in front of the "\" or the "/"
					stemp.Mid(&vtemp, itemp + 1, (stemp.GetLength() - itemp) - 1);
					stemp.Set(vtemp.Get());
					itemp = stemp.Instr("\\", 0);
					if (itemp < 0)
					{
						itemp = stemp.Instr("/", 0);
					}
				}
				// Output the file
				addfile(&stemp, resfile, &wad);

				// Set up for the next wad file in the total wad list
				strstart = markpos + 1;
				if (!wadend) { markpos = line.Instr(";", strstart); }
			}

			wadnext = false; // The next files won't be the wadlist!
		}
		else
		{
			// Do we have an arg?
			if (entryarg)
			{
				entryarg = false; // The next line will be a name.

				line.Right(&vtemp, 4);
				// We parse the string and add it to our res file if it's a legal string
				if (strcmp(vtemp.Get(), ".mdl") == 0)
				{
					// We have a model, output it!
					addfile(&line, resfile, &model);
				}
				else if (strcmp(vtemp.Get(), ".wav") == 0)
				{
					// We have a sound, output it!
					addfile(&line, resfile, &sound, "sound/");
				}
				else if (strcmp(vtemp.Get(), ".spr") == 0)
				{
					// We have a sprite, output it!
					// Strip any leading / from the entry
					addfile(&line, resfile, &sprite);
				}
				else if (strcmp(vtemp.Get(), ".bmp") == 0)
				{
					// We have a bitmap, output it!
					addfile(&line, resfile, &bitmap);
				}
				else if (strcmp(vtemp.Get(), ".tga") == 0)
				{
					// We have a targa, output it!
					addfile(&line, resfile, &targa);
				}
			}
			else
			{
				entryarg = true; // The next line will be a arg.
				if (strcmp(line.Get(), "skyname") == 0)
				{
					// We have a skyname in the next string!
					skynext = true;
				}
				else if (strcmp(line.Get(), "wad") == 0)
				{
					// We have a wadfile-list in the next string!
					wadnext = true;
				}
			}
		}
		#ifndef _WIN32
		if (statusline && statcount == STAT_MAX)
		{
			// Reset the statcount
			statcount = 0;

			// Calculate the percentage completed of the current file. We add one to make 100% appear too.
			// Normally it would only appear for a few msec before the next file will be done :)
			percentage = ((j+1) * 101) / entdatalen; // Make the length one too long.
			if (percentage > 100) { percentage = 100; } // Make sure we don't do 101 percent
			printf("\r(%d\%) [%d/%d]", percentage, currentbsp, totalbsp);
		}
		else
		{
			statcount++;
		}
		#endif
	}

	UnLoadBSPEntityInfo(); // We are done with the entity data so unload the mem reserved for that data

	// Add additionfile string if wanted or just a final newline.
	if (addition)
	{
		fprintf(resfile, "\n\n%s", additionstring);
	}
	else
	{
		fprintf(resfile, "\n");
	}


	// Close the resfile
	fclose(resfile);

	if (verbal)
	{
		// Many update status here... The status line will blink if it isn't called this often.
		#ifdef _WIN32
		upstatus();
		#endif
		printf("\r----------------------------------------\n"); // print a line
		#ifdef _WIN32
		upstatus();
		#endif
		printf("%s has been made!\n", resfilename.Get());
		#ifdef _WIN32
		upstatus();
		#endif
		printf("\n");
		#ifdef _WIN32
		upstatus();
		#endif
	}

	return 0;
}


void givecredits()
{
	printf("Special thanks to:\n");
	printf("  \"luvless??\" for his help with the BSP and RES format!\n");
	printf("  \"HoundDawg\" for hosting this program!\n");
	printf("  \"Alfred\" for his help with MSVC++!\n");
	printf("  \"mjr\" for his help with MSVC++, some speed tips and RESGen linux!\n");
	printf("  Valve for creating Half-Life!\n");
	printf("  All the other admins at #hlds for general support!\n\n");

	#ifdef _WIN32
	getexitkey();
	#endif
	exit(0);
}


void givehelp(helptype help, bool verbaloverride = false)
{
	if (verbal || verbaloverride)
	{
		printf("ResGen help.\n\n");

//		Win32 console size
//		       0         1         2         3         4         5         6         7         8
//		        12345678901234567890123456789012345678901234567890123456789012345678901234567890
		printf("Command line parameters:\n");
		printf(" [mapname]        Same as -f\n");
		printf(" -h               Displays this help screen\n");
		printf(" -v               Put ResGen in silent mode (no console output)\n");
		#ifndef _WIN32
		printf(" -i               Do not display current search directory\n");
		#endif
		printf(" -s               Do not display the status line\n");
		printf(" -l               Do not convert res entries to lowercase\n");
		printf(" -f [mapname]     Process this map (can be used mulitple times)\n");
		printf(" -d [dir]         Process directory (current dir without [dir] argument)\n");
		printf(" -r [dir]         Same as -d but processes subdirs too\n");
		#ifndef _WIN32
		printf(" -t               Ignore symbolic links when searching directories\n");
		#endif
		printf(" -o               Overwrite existing res-files\n");
		printf(" -u [dd-mm-yyyy]  Only overwrites res-files older then [dd-mm-yyyy]\n");
		printf(" -a [filename]    Adds [filename.rfa] (.rfa optional) to processed res files\n");
		#ifdef _WIN32
		printf(" -w               RESGen will not wait for a keypress to exit in verbal mode\n");
		#endif
		printf(" -c               Displays credits\n");

		printf("\nExample:\n");
		printf("   resgen -f boot_camp.bsp\n\n");

		printf("Read RESGen.txt for more information!\n");

		// ResGen command line parameters
		// no args         : Gives help.
		// [filename]      : Do a single file (can be more then one)
		// -h              : gives help
		// -v              : no output to console
		// -s              : no status line
		// -i              : linux - don't display what directory we are searching -s also disables this
		// -l              : linux compatiblity override. Prevents converting all resgen entries to lowercase.
		// -f [filename]   : do file (can be more then one)
		// -d [dir]        : Do a single dir (does current dir without specfied dir)
		// -r [dir]        : Do dir and subdirs (does current dir without specfied dir)
		// -t              : Ignore symbolic links when searching directories
		// -o              : Overwrites any res file.
		// -u [dd-mm-yyyy] : updates any res file older then mm-dd-yyyy.
		// -a [filename]   : adds the file [filename.rfa] to all res files processed.
		// -w              : deactivates windows console mode (exits without waiting for keypress)
		// -c              : Gives full credits

		switch (help)
		{
			case files_help:
				printf("ERROR: You need to specify files to process\n\n");
				break;

			case dirs_help:
				printf("ERROR: The dir you specified contains no .bsp files\n\n");
				break;

		}

		#ifdef _WIN32
		getexitkey();
		#endif
	}

	if (help != no_help)
	{
		exit(3);
	}
	else
	{
		exit(0);
	}
}

#ifdef _WIN32
// Win32 listdir
void listdir(VArray *filelist, VString *startdir, bool subdir, bool firstdir = true)
{
	VString vtemp;
	VString searchpath;
	WIN32_FIND_DATA filedata;
	HANDLE filehandle;

	// Get all files from the dir(s)
	// Check if the dir ends with a "\". If not, add it. - Win32
	startdir->Right(&vtemp, 1);
	if (strcmp(vtemp.Get(), "\\"))
	{
		// No ending "\"
		startdir->Cat("\\");
	}

	// add a *.* to the end for the search - Win32
	searchpath.Set(startdir->Get());
	searchpath.Cat("*.*");

	// Display a cute message
	if (verbal && firstdir)
	{
		if (subdir)
		{
			printf("Searching %s for bsp files and subdirectories:\n", startdir->Get());
		}
		else
		{
			printf("Searching %s for bsp files:\n", startdir->Get());
		}
	}

	if (statusline)
	{
		strlimcpy(sbar2, startdir->Get(), 80);
		upstatus();
	}
	
	// Find the first file or subdir in the specified dir
	filehandle = FindFirstFile(searchpath.Get(), &filedata);

	// Start going through dirs finding files.
	do
	{
		if (filehandle == INVALID_HANDLE_VALUE && firstdir)
		{
			if (GetLastError() & ERROR_PATH_NOT_FOUND || GetLastError() & ERROR_FILE_NOT_FOUND)
			{
				printf("The directory you specified (%s) can not be found or is empty.\n", startdir->Get());
				exit(1);
			}
			else
			{
				printf("There was an error with the directory you specified (%s) - ERROR NO: %d.\n", startdir->Get(), GetLastError());
			exit(1);
			}
		}

		// Do we have a dir?
		if (filedata.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
		{
			// We have a dir! Is subdir mode on?
			if (subdir)
			{
				// Subdir mode is on! Check if these dir's aren't "." or "..".
				// If they would be searched the program would end a horrible death of infinite loops!
				if (strcmp(filedata.cFileName, ".") && strcmp(filedata.cFileName, ".."))
				{
					// Call this function recursive
					// create the new dir path
					vtemp.Set(startdir->Get());
					vtemp.Cat(filedata.cFileName);
					
					listdir(filelist, &vtemp, subdir, false); // Not the first dir, so last arg is false
				}
			}
		}
		else
		{
			// check if the file is a bsp file
			vtemp.Set(filedata.cFileName);
			vtemp.Right(&vtemp, 4);

			// Verify extension. If it's ok, add it.
			if (stricmp(vtemp.Get(), ".bsp") == 0)
			{
				filelist->Add(startdir->Get());
				filelist->GetLast()->Cat(filedata.cFileName);
				if (verbal)
				{
					printf("Found: %s\n", filedata.cFileName);
					upstatus();
				}
			}
		}
	} while (FindNextFile(filehandle, &filedata));

	return;
}
#else
// Linux listdir
void listdir(VArray *filelist, VString *startdir, bool subdir, bool firstdir = true)
{
	VString vtemp;

	DIR *directory;
	dirent *direntry;
	struct stat filestatinfo; // Needs the 'struct' in front of it... GCC won't see it as a struct

	int itemp; // Temp int

	// Get all files from the dir(s)
	// Check if the dir ends with a "/". If not, add it. - Linux
	startdir->Right(&vtemp, 1);
	if (strcmp(vtemp.Get(), "/"))
	{
		// No ending "/"
		startdir->Cat("/");
	}

	// Display a cute message
	if (verbal && firstdir)
	{
		if (subdir)
		{
			printf("Searching %s for bsp files and subdirectories:\n", startdir->Get());
		}
		else
		{
			printf("Searching %s for bsp files:\n", startdir->Get());
		}
	}

	// status bar
	if (statusline && displaydir)
	{
		printf("Searching: %s\n", startdir->Get());
	}

	// Open the current dir
	directory = opendir(startdir->Get());
	// Is it open?
	if (directory == NULL)
	{
		// dir cannot be opened
		if (firstdir)
		{
			printf("There was an error with the directory you specified (%s)\nDid you enter the correct directory?\n", startdir->Get());
			exit(1);
		}
		return;
	}

	// Start going through dirs finding files.
	while (direntry = readdir(directory))
	{
		// Do we have a dir?
		vtemp.Set(startdir->Get());
		vtemp.Cat(direntry->d_name);

		if (linktrace)
		{
			itemp = stat(vtemp.Get(), &filestatinfo); // Get the info about the files teh links point to
		}
		else
		{
			itemp = lstat(vtemp.Get(), &filestatinfo); // Get the info about the links
		}

		if (itemp == 0)
		{
			if (!S_ISLNK(filestatinfo.st_mode) || linktrace)
			{
				// We have a file! Is it a dir?
				if (S_ISDIR(filestatinfo.st_mode))
				{
					// Is subdir mode on?
					if (subdir)
					{
						// Subdir mode is on! Check if these dir's aren't "." or "..".
						// If they would be searched the program would end a horrible death of infinite loops!
						if (strcmp(direntry->d_name, ".") && strcmp(direntry->d_name, ".."))
						{
							// Call this function recursive
							listdir(filelist, &vtemp, subdir, false); // Not the first dir
						}
					}
				}
				else
				{
					// check if the file is a bsp file
					vtemp.Set(direntry->d_name);
					vtemp.Right(&vtemp, 4);

					// Verify extension. If it's ok, add it.
					if (stricmp(vtemp.Get(), ".bsp") == 0)
					{
						filelist->Add(startdir->Get());
						filelist->GetLast()->Cat(direntry->d_name);
						if (verbal)
						{
							printf("Found: %s\n", direntry->d_name);
						}
					}
				}
			}
		}
	}

	// close the dir
	closedir(directory);

	return;
}
#endif

int main(int argc, char* argv[])
{
	VString vtemp; // Needed because of VString's inability to overload.

	VArray args; // Stores all args
	VArray filelist; // List of BSP files to process
	VString startdir; // The dir to search files
	VString additionfile; // The name of the additionfile

	char *tmpchar; // Temp pointer to a char(array)

	VArray errorlist; // list with errors

	bool help = false; // Turn help off
	bool credits = false; // Turn credits off
	bool dir = false; // Do we have a dir next?
	bool subdir = false; // Do we have a subdir next?

	bool dirnext = false; // Will the next thing be a dir?
	bool updatenext = false; // Will the next thing be an update date?
	bool additionnext = false; // Will the next thing be an addition file?

	int i; // Temp counter
	int j; // Temp counter
	int itemp; // Temp integer

	int errorcode; // Errorcode for makeres

	#ifdef _WIN32
	// Empty the status bars
	sprintf(sbar1, "Resource File Generator v%s. Made by Jeroen \"ShadowLord\" Bogers", version);
	sprintf(sbar2, "For more info go to: http://www.unitedadmins.com/mapRESGEN.asp");
	upstatus();

	houtput = GetStdHandle (STD_OUTPUT_HANDLE); // Get the console output handle
	#endif

	// Put argv in args
	for (i=0; i < argc; i++)
	{
		args.Add(argv[i]);
	}

	// Process args (ignores first arg, which is the program name)
	for (i=1; i < argc; i++)
	{
		tmpchar = args.Get(i)->Get();
		if (tmpchar[0] == '-')
		{
			// We have a arg setting... Clear any -next- boolean
			updatenext = false;
			additionnext = false;
			dirnext = false;
			for (j=1; j <= (int)strlen(tmpchar); j++)
			{
				if (tmpchar[j] == 'h')
				{
					help = true;
					break; // Brake, we don't need any other vars anyways
				}
				else if (tmpchar[j] == 'v')
				{
					verbal = false;
					statusline = false;
				}
				#ifndef _WIN32
				else if (tmpchar[j] == 'i')
				{
					displaydir = false;
				}
				#endif
				else if (tmpchar[j] == 's') 
				{
					statusline = false;
				}
				else if (tmpchar[j] == 'l') 
				{
					lowercase = false;
				}
				else if (tmpchar[j] == 'f')
				{
					// Do nothing, next will be seen as file anyways.
				}
				else if (tmpchar[j] == 'd')
				{
					dirnext = true;
					dir = true;
				}
				else if (tmpchar[j] == 'r')
				{
					dirnext = true;
					subdir = true;
					dir = true;
				}
				#ifndef _WIN32
				else if (tmpchar[j] == 't')
				{
					linktrace = false;
				}
				#endif
				else if (tmpchar[j] == 'o')
				{
					overwrite = true;
				}
				else if (tmpchar[j] == 'u')
				{
					updatenext = true;
					update = true;
				}
				else if (tmpchar[j] == 'a')
				{
					additionnext = true;
					addition = true;
				}
				#ifdef _WIN32
				else if (tmpchar[j] == 'w')
				{
					winconsole = false;
				}
				#endif
				else if (tmpchar[j] == 'c')
				{
					credits = true;
					break; // Brake, we don't need any other vars anyways
				}
			}
		}
		else if (updatenext)
		{
			makedate(args.Get(i), &updday, &updmonth, &updyear);
			updatenext = false;
		}
		else if (additionnext)
		{
			additionfile.Set(args.Get(i)->Get());
			additionnext = false;
		}
		else if (dirnext)
		{
			startdir.Set(args.Get(i)->Get());
			dirnext = false;
		}
		else
		{
			dirnext = false;
			filelist.Add(args.Get(i)->Get());
		}
	}

	// Small credits at start - always
	#ifdef _WIN32
	if (statusline) { printf("\n\n"); }
	#endif

	printf("Resource File Generator v%s. Made by Jeroen \"ShadowLord\" Bogers\n", version);
	printf("For more info go to: http://resgen.hltools.com\n");
	if (verbal)
	{
		printf("\n");
	}
	else
	{
		printf("Generating RES files. Please stand by...\n");
	}

	if (help || (argc < 1)) { givehelp(no_help, true); } // Run normal help
	if (credits) { givecredits(); } // Run the credits

	// Find files for a certain dir (and subdir)
	if (dir)
	{
		#ifdef _WIN32
		// Print to the status bar we are doing a dir-search
		strcpy(sbar1, "Searching directories...");
		upstatus();
		#endif

		if (startdir.GetLength() == 0)
		{
			startdir.Set(".");
		}
		listdir(&filelist, &startdir, subdir);
		if (verbal) { printf("\nDirectory search complete. Found %d bsp files!\n\n", filelist.GetCount()); }
		#ifdef _WIN32
		strcpy(sbar1, "Directory search done!");
		sprintf(sbar2, "Found %d bsp files.", filelist.GetCount());
		upstatus();
		#endif
	}

	// Check if there are any files specified
	if (filelist.GetCount() == 0)
	{
		if (dir)
		{
			givehelp(dirs_help);
		}
		else
		{
			givehelp(files_help, true);
		}
	}

	// Move the contents of the additionfile into additionstring if there is an additionfile
	if (addition)
	{
		// Verify extension. If it's not there/wrong add it
		additionfile.Right(&vtemp, 4);
		// If it's still incorrect people will see the appropriate error message anyways.
		if (stricmp(vtemp.Get(), ".rfa") != 0)
		{
			vtemp.Set(additionfile.Get());
			vtemp.Cat(".rfa");
		}
		else
		{
			vtemp.Set(additionfile.Get());
		}

		if (LoadFile(vtemp.Get(), (void **)&additionstring) == -1)
		{
			printf("    ERROR: The RFA file \"%s\" could not be found.\n           Wrong filename?\n", additionfile.Get());
			#ifdef _WIN32
			getexitkey();
			#endif
			exit(4);
		}
	}

	// Parse all BSP files in the BSP file-list
	itemp = filelist.GetCount();
	#ifdef _WIN32
	strcpy(sbar2, "");
	#endif

	for (i=0; i < filelist.GetCount(); i++)
	{
		// Parse the BSP file
		#ifdef _WIN32
		if (statusline)
		{
			sprintf(sbar1, "ResGen v%s - Total progress: [", version);
			progressbar(sbar1, filelist.GetCount(), i+1, 79 - strlen(sbar1));
			strcat(sbar1, "]");
			upstatus();
		}
		#else
		totalbsp = filelist.GetCount();
		currentbsp = i+1;
		#endif

		errorcode = MakeRes(filelist.Get(i)->Get()); // Generate the res file
		// Check for errors
		if (errorcode == 1)
		{
			sprintf(tmpchar, "    ERROR: BSP file \"%s\" not found or incorrect filetype!\n           Wrong filename? Or did you try to do a non HL BSP file?", filelist.Get(i)->Get());
			errorlist.Add(tmpchar);
		}
		else if (errorcode == 3)
		{
			sprintf(tmpchar, "    ERROR: BSP file \"%s\" has a syntax error.\n           Corrupted BSP file?\n", filelist.Get(i)->Get());
			errorlist.Add(tmpchar);
		}
		else if (errorcode == 4)
		{
			sprintf(tmpchar, "  WARNING: The RES file for \"%s\" has not been generated.\n           A resfile already exists for that file.\n", filelist.Get(i)->Get());
			errorlist.Add(tmpchar);
		}
		else if (errorcode == 5)
		{
			sprintf(tmpchar, "  WARNING: The RES file for \"%s\" has not been updated.\n           A newer resfile already exists for that file.\n", filelist.Get(i)->Get());
			errorlist.Add(tmpchar);
		}
	}

	// Wait for key in verbal mode.
	if (verbal)
	{
		#ifdef _WIN32
		strcpy(sbar1, "Done with creating res file(s)!");
		sprintf(sbar2, "%d file(s) were generated.", filelist.GetCount() - errorlist.GetCount());
		#endif

		// Print errors if they occured
		for (i=0; i < errorlist.GetCount(); i++)
		{
			printf("%s", errorlist.Get(i)->Get());
			#ifdef _WIN32
			upstatus();
			if ((i % 11) == 10)
			{
				getcontkey();
			}
			#endif
		}

		// Print exit message
		printf("\nDone with creating res file(s)! %d file(s) were generated.\n", filelist.GetCount() - errorlist.GetCount());
		#ifdef _WIN32
		upstatus();

		getexitkey();
		#endif
	}
	else
	{
		// Print exit message for non-verbal mode.
		if (errorlist.GetCount() > 0)
		{
			printf("An error occured. Not all RES files might have been properly generated.\n");
			printf("Run RESGen in verbal mode for more information\n");
		}
		else
		{
			printf("Done.\n");
		}
	}
	
	// Return a 1 if there was a error
	if (errorlist.GetCount() > 0) { exit(1); }

	return 0;
}


void makedate(VString *strdate, int *rday, int *rmonth, int *ryear)
{
	int sep1, sep2; // Seperator positions
	VString vtemp; // Temp string

	// Get seperators
	sep1 = strdate->Instr("-", 0);
	sep2 = strdate->Instr("-", sep1 + 1);

	// Get the day
	strdate->Left(&vtemp, sep1);
	sscanf(vtemp.Get(), "%d", rday);

	// Get the month
	strdate->Mid(&vtemp, sep1 + 1, (sep2 - sep1) - 1);
	sscanf(vtemp.Get(), "%d", rmonth);

	// Get the year
	strdate->Right(&vtemp, (strdate->GetLength() - sep2) - 1);
	sscanf(vtemp.Get(), "%d", ryear);
}


void getdate(VString *strdate)
{
	char ctemp[15]; // Temp char array
	tm *gmt; // Stores gmtime in struct tm
	time_t systime; // Stores the system time in a long called time_t

	time(&systime); // Get the current system tyme and store it in a long called time_t
	gmt = gmtime(&systime); // Get the current GMT time and store it in a tm structure
	
	sprintf(ctemp, "%02d-%02d-%04d", gmt->tm_mday, gmt->tm_mon + 1, gmt->tm_year + 1900); // format date [dd-mm-yyyy]
	strdate->Set(ctemp);
}

#ifdef _WIN32
void getexitkey()
{
	if (winconsole)
	{
		printf("Press any key to exit");
		upstatus();
		getch();
	}
}


void getcontkey()
{
	if (winconsole)
	{
		printf("Press any key to continue");
		upstatus();
		getch();
		printf("\n");
	}
}
#endif


bool fgetline(FILE *txtfile, VString *line)
{
	char temp[11];
	int tmpchar;
	int i;

	tmpchar = fgetc(txtfile);
	while (tmpchar != EOF && tmpchar != '\n')
	{
		for (i=0; i < 10 && tmpchar != EOF && tmpchar != '\n'; i++)
		{
			temp[i] = tmpchar;

			tmpchar = fgetc(txtfile);
		}
		temp[i] = 0;
		line->Cat(temp);
	}
	if (tmpchar == EOF)
	{
		return false;
	}

	return true;
}

void MemError()
{
	printf("\n\nMemory allocation error (RESGen main).\n");
	printf("Try to free more memory on your computer\n\n");
	printf("If this fails contact resgen@hltools.com\n");
	exit(2);
}